// Alfa.cpp : implementation file
//

#include "stdafx.h"
#include "alfa.h"
#include "Alfa.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/*
Nice to know when you investigate this class:

The GLYPHMETRICSFLOAT structure contains information 
about the placement and orientation of a glyph in a 
character cell.
typedef struct _GLYPHMETRICSFLOAT {    
    FLOAT      gmfBlackBoxX; 
    FLOAT      gmfBlackBoxY; 
    POINTFLOAT gmfptGlyphOrigin; 
    FLOAT      gmfCellIncX; 
    FLOAT      gmfCellIncY; 
} GLYPHMETRICSFLOAT; 

*/
//////////////////////////////////////////////
// helper to draw a box

void DrawBox()
{
	// draws the sides of a unit cube (0,0,0)-(1,1,1)

	glBegin(GL_POLYGON);//f1: front
		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);//f2: bottom
		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f3:back
		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f4: top
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f5: left
		glNormal3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f6: right
		glNormal3f(0.0f,-1.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,1.0f,0.0f);
	glEnd();
}

/////////////////////////////////////////////////////////////////////////////
// CAlfa dialog


CAlfa::CAlfa()
{
	m_Txt = _T("Hello");
	m_TList.RemoveAll();
	m_extrude=0.2f;
	m_Start_List=-1;

	// layout
	m_bVertical=TRUE;
	m_AsBox=FALSE;

	// init font as ARIAL
	memset(&m_lf,0,sizeof(LOGFONT));
	m_lf.lfHeight			=-20;
	m_lf.lfWeight			=FW_NORMAL;
	m_lf.lfCharSet			=ANSI_CHARSET;
	m_lf.lfOutPrecision		=OUT_DEFAULT_PRECIS;
	m_lf.lfClipPrecision	=CLIP_DEFAULT_PRECIS;
	m_lf.lfQuality			=DEFAULT_QUALITY;
	m_lf.lfPitchAndFamily	=FF_DONTCARE|DEFAULT_PITCH;
	lstrcpy(m_lf.lfFaceName,"Arial");
}

BEGIN_MESSAGE_MAP(CAlfa, CCmdTarget)
	//{{AFX_MSG_MAP(CAlfa)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlfa operations

void CAlfa::CalculateString()
{
	/////////////////////////////////
	// function calculates:
	//	m_leading, line height
	//	m_max_line_length, max line length
	
	/////////////////////////
	// split string m_Txt up in lines, 
	// based on cr-lf as delimiter
	
	CString S=m_Txt;
	// split into lines
	int ix=0;
	m_TList.RemoveAll();
	int pos;
	do
	{
		pos=S.Find('\r');
		if(pos!=-1)
		{
			m_TList.Add(S.Left(pos));
			S=S.Mid(pos+2);// drop lf
		}

	} while((pos!=-1)&&(ix<4));
	if((ix<4)&&(S.GetLength()>0))
		m_TList.Add(S);

	//////////////////////////////////
	// calculate following:
	// m_leading and m_max_line_length

	int nlines=m_TList.GetSize();
	GLfloat Len=0.0f;
	m_max_line_length=0.0f;
	for(ix=0;ix<nlines;ix++)
	{
		Len=0.0f;
		for(int i=0;i<m_TList[ix].GetLength()-1;i++)
			Len+=m_gmf[__toascii(m_TList[ix][i])].
							gmfCellIncX;

		if(Len>m_max_line_length)
			m_max_line_length=Len;
	}
	// leading as an approx
	m_leading=1.3f*m_gmf[__toascii('H')].gmfBlackBoxY;

}

void CAlfa::CreateFont3D()
{
	// this function needs a rendering context to be selected
	// set up fontlists
	// delete old lists if any
	if(m_Start_List!=-1)
		glDeleteLists(m_Start_List,256);
	
	// liststart at any old number
	m_Start_List=glGenLists(256);
	
	// Get the DC for the rendering context	
	HDC hdc = wglGetCurrentDC();
	CDC* pdc = CDC::FromHandle(hdc);
	
	// make and select in the font
	HFONT hFont,hOldFont;
	hFont=CreateFontIndirect(&m_lf);
	hOldFont=(HFONT)SelectObject(hdc,hFont);
	// create displaylists, this is the crux
	// and it steals some time
	// could be handmade in view for fewer letters
	if(
		!(wglUseFontOutlines(
		hdc,				// device context of the outline font
		0,					// first glyph to be turned into a display list
		255,				// number of glyphs to be turned into display lists		
		m_Start_List,		// specifies the starting display list
		0.0f,				//quality, 0 is max
		m_extrude,			// extrusion value in the negative z direction
		WGL_FONT_POLYGONS,	// or WGL_FONT_LINES
		m_gmf				// address of buffer to receive glyph metric data
		))
		)
		ASSERT(FALSE);		// good enough for this prog

	wglMakeCurrent(0,0);	
	// dont need the font anymore, only the lists
	// are relevant when GL renders chars
	DeleteObject(SelectObject(hdc,hOldFont));
	// called at start and once too many later on
	// no problem
	CalculateString();
}

BOOL CAlfa::SetNewFont()
{
	// let user select font
	CFontDialog FD;
	FD.m_cf.lpLogFont=&m_lf;

	if(FD.DoModal()==IDOK)
	{
		// only bother about face and weight
		// This is not so good, since user
		// may expect effect of all items in dialogbox
		CString S=FD.GetFaceName();
		lstrcpy(m_lf.lfFaceName,S);
		m_lf.lfWeight=FD.GetWeight();
		CreateFont3D();
		return TRUE;
	}
	return FALSE;
}


void CAlfa::Draw3DText()
{
	// will allways cull backsides
	// since we only render closed shapes
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	// draw the text centered about origo
	for(int ix=0;ix<m_TList.GetSize();ix++)
	{
		glPushMatrix();
		CString S=m_TList[ix];

		if(!m_bVertical)
			glTranslatef(	-0.5f*m_max_line_length,
							0.0f,
							-2.0f*ix*m_extrude);
		else
			glTranslatef(	-0.5f*m_max_line_length,
							0.5f*(GLfloat)(m_TList.GetSize())*m_leading-(GLfloat)ix*m_leading,
							0.0f);

		// special treatment of Norv.
		// other solutions ?
		int n,lastn;
		for(int six=0;six< S.GetLength();six++)
		{
			switch(S[six])
			{
				case '':n=248;break;
				case '':n=216;break;
				case '':n=229;break;
				case '':n=197;break;
				case '':n=230;break;
				case '':n=198;break;
				default:n=__toascii(S[six]);
			}
			// draw as text or box ?
			if(!m_AsBox)
				glCallList(m_Start_List+n);
			else
			{
				if(six>0)
					glTranslatef(m_gmf[lastn].gmfCellIncX,0.0f,0.0f);

				glPushMatrix();
				glScalef(m_gmf[n].gmfBlackBoxX,
						 m_gmf[n].gmfBlackBoxY,
						 m_extrude);
				DrawBox();
				glPopMatrix();
			}
			lastn=n;
		}
		glPopMatrix();
 	}
	glDisable(GL_CULL_FACE); // disable culling
}

GLfloat CAlfa::GetEssayWidth()
{
	// return complete length extension
	return m_max_line_length;
}

GLfloat CAlfa::GetEssayHeight()
{
	// return complete height extension
	return (GLfloat)m_TList.GetSize()*m_leading;
}


void CAlfa::SetText(CString &S)
{
	// sets the text
	m_Txt=S;
	CalculateString();
}

void CAlfa::GetText(CString &S)
{
	// retrieves the string
	S=m_Txt;

}

void CAlfa::SetLayout(BOOL bVertical/*=FALSE*/)
{
	m_bVertical=bVertical;
	CalculateString();
}

void CAlfa::SetExtrude(GLfloat ext)
{
	// changes the depth of the chars
	if(ext<=0.0f)
		ext=0.0f;
	m_extrude=ext;
	CreateFont3D();
	CalculateString();
}

